/************************************************************************/
/*                                                                      */
/* FILE NAME : DEn.c                                                    */
/*                                                                      */
/************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>

struct point
{ float x;
  float y;
  struct KERPointNode *KerPair;
};

struct line
{ struct point first;
  struct point next;
};

struct lineNode
{  struct line MyLine;
   struct lineNode *NextEle;
};

struct VisiblePolyEle
{  int index;
   struct VisiblePolyEle *NextEle;
};

struct PointNode
{ struct point MyPoint;
  int MyIndex;
  struct VisiblePolyEle *VisibilityPolyList;
  struct PointNode *NextEle;
};

struct BaseTriangleEle   /* triangle (first,middle,last) */
{  int first;
   int middle;
   int last;
   struct BaseTriangleEle *NextEle;
};

struct SubPolyNode
{  int from;
   int to;
   struct BaseTriangleEle *BaseTrianglesList;
   struct SubPolyNode *NextEle;
};

struct MDElement
{  int from;
   int to;
   struct StarPolygon *RealMDList;
   int NumberOfRealList;
   struct StarPolygon *PseudoMDList;
   int NumberOfPseudoList;
};

struct NewMDElement
{  struct StarPolygon *RealMDList;
   int NumberOfRealList;
};


struct StarPolygon
{ int numberOfPoints;
  int *elements;
  struct StarPolygon *NextEle;
};

struct KERPointNode
{ struct point MyPoint;
  int MyIndex;
  struct VisiblePolyEle *VisibilityPolyList;
  struct KERPointNode *NextEle;
  int *component_num;
  struct StarPolygon **MinDecompList;
  int *psecomp_num;
  struct StarPolygon **PseudoDecompList;
};

typedef struct point Point;

typedef struct line Line;

void code(int *array, struct StarPolygon *List, int num_elements)
{ struct StarPolygon *ptr;
  int i=0,j;
  array[i]=num_elements;
  ptr=List;i++;
  while(ptr!=NULL)
  { array[i] = ptr->numberOfPoints;
	i++;
	for(j=0;j<ptr->numberOfPoints;j++)   array[j+i]=ptr->elements[j];
	i+= ptr->numberOfPoints;
	ptr=ptr->NextEle;
  }/* end of while */
}/* end of code() */

void print_code(int *array)
{ int num_set;
  int i,max,num_ele,j,k;
  printf("\n ------ %d %d %d %d %d ",array[0],array[1],array[2],array[3],array[4]);
  num_set=array[0];

  i=0;k=1;
  while(i<num_set)
  { printf("\n Set %d : ( ",i);
	for(j=0;j<(array[k]-1);j++)
	  printf(" %d, ",array[k+j+1]);
	printf(" %d ) ",array[k+j+1]);j++;

	k+=(j+1);
	i++;
  }/* end of while */

}/* end of print_code() */

struct StarPolygon *StarListProvide(struct StarPolygon **List,int *num_ele)
{ struct StarPolygon *ptr;
  struct StarPolygon *first=NULL;
  int i=0,p,k=0;
  if((ptr=(struct StarPolygon *)calloc(1,sizeof(struct StarPolygon)))!=NULL)
  { ptr->elements=NULL;
	ptr->NextEle=NULL;
	ptr->numberOfPoints=0;
	first=ptr;k=1;
	if((ptr->elements=(int *)calloc(5,sizeof(int)))!=NULL)
	{ ptr->numberOfPoints=5;
	  for(p=0;p<5;p++) ptr->elements[p]=p*p;
	  i=1;
	  while(i<5)
	  {
		if((ptr=(struct StarPolygon *)calloc(1,sizeof(struct StarPolygon)))!=NULL)
		{ ptr->elements=NULL;
		  ptr->NextEle=NULL;
		  ptr->numberOfPoints=0;
		  if((ptr->elements=(int *)calloc(i*3,sizeof(int)))!=NULL)
		  { ptr->numberOfPoints=i*3;
			for(p=0;p<i*3;p++) ptr->elements[p]=p*i*i;
			ptr->NextEle=first;
			first=ptr;
			k++;
		  }/* end of while */
		}/* end of while */
		i++;

	  }/* end of while */
	}/* end of if */
  }/* end of if */
  *List=first;
  *num_ele=k;
  return(first);
}/* end of StarListProvide() */

void print_StarList(struct StarPolygon *List)
{ struct StarPolygon *ptr;
  int j;
  ptr=List;
  while(ptr!=NULL)
  {  printf("\n Element Number : %d = ( ",ptr->numberOfPoints);
	 for(j=0;j<(ptr->numberOfPoints-1);j++)
	   printf(" %d, ",ptr->elements[j]);
	 printf(" %d )",ptr->elements[j]);
	 ptr=ptr->NextEle;
  }/* end of while() */
  printf("\n");
}/* end of print_StarList() */

void decode(int *array, struct StarPolygon **List, int *num_ele)
{ int i,j,k;
  struct StarPolygon *ptr;
  struct StarPolygon *first=NULL;
  *num_ele=array[0];
  i=0; j=1;
  while(i<array[0]&&((ptr=(struct StarPolygon *)calloc(1,sizeof(struct StarPolygon)))!=NULL))
  { if(i==0) first=ptr;
	ptr->NextEle=NULL;
	ptr->numberOfPoints=0;
	ptr->elements=NULL;
	if((ptr->elements=(int *)calloc(array[j],sizeof(int)))!=NULL)
	{ ptr->numberOfPoints=array[j];j++;
	  for(k=0;k<ptr->numberOfPoints;k++)
		 ptr->elements[k]=array[j+k];
	  j+=k;
	  if(i!=0)
	  {  ptr->NextEle = first;
		 first = ptr;
	  }/* end of if */
	}/* end of if */
	i++;
  }/* end of while() */
  *List = first;
  *num_ele = i;
}/* end of decode() */

void main()
{ int *array;
  int max=10;
  int num_element=10;
  int num_ele2;
  struct StarPolygon *StarList;
  struct StarPolygon *StarList2;

  if((array=(int *)calloc(max*(max+1),sizeof(int)))!=NULL)
  {  if(StarListProvide(&StarList,&num_element))
	 {  print_StarList(StarList);
		code(array,StarList,num_element);
		print_code(array);
		decode(array,&StarList2,&num_ele2);
		print_StarList(StarList2);
	 }
  }/* end of if */
}/* end of main() */